/*
 * #%L
 * OME-XML C++ library for working with OME-XML metadata structures.
 * %%
 * Copyright © 2006 - 2016 Open Microscopy Environment:
 *   - Massachusetts Institute of Technology
 *   - National Institutes of Health
 *   - University of Dundee
 *   - Board of Regents of the University of Wisconsin-Madison
 *   - Glencoe Software, Inc.
 * %%
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of any organization.
 * #L%
 */

/*─────────────────────────────────────────────────────────────────────────────
 *
 * THIS IS AUTOMATICALLY GENERATED CODE.  DO NOT MODIFY.
 *
 *─────────────────────────────────────────────────────────────────────────────
 */

#ifndef OME_XML_MODEL_SCREEN_H
#define OME_XML_MODEL_SCREEN_H

#include <algorithm>
#include <list>
#include <stdexcept>
#include <string>
#include <vector>

#include <ome/common/log.h>

#include <ome/common/xml/dom/Document.h>
#include <ome/common/xml/dom/Element.h>
#include <ome/common/xml/dom/Node.h>

#include <ome/xml/model/primitives/Quantity.h>

#include <ome/xml/model/detail/OMEModelObject.h>

namespace ome
{
  namespace xml
  {
    namespace model
    {

      // Forward declarations.
      class Annotation;
      class OMEModel;
      class Plate;
      class Reagent;

      /**
       * Screen model object.
       */
      class Screen : public detail::OMEModelObject
      {
      private:
        class Impl;
        /// Private implementation details.
        std::shared_ptr<Impl> impl;

      public:
        /// Default constructor.
        Screen();

        /**
         * Copy constructor.
         *
         * @param copy the Screen to copy.
         */
        Screen (const Screen& copy);

        /// Destructor.
        virtual
        ~Screen ();

        /**
         * Create a Screen model object from DOM element.
         *
         * @param element root of the XML DOM tree to from which to
         * construct the model object graph.
         * @param model handler for the OME model used to track
         * instances and references seen during the update.
         * @throws EnumerationException if there is an error
         * instantiating an enumeration during model object creation,
         * or ModelException if there are any consistency or validity
         * errors found during processing.
         *
         * @returns a new model object.
         */
        static std::shared_ptr<Screen>
        create(const common::xml::dom::Element& element,
               ome::xml::model::OMEModel& model);

        // Documented in superclass.
        const std::string&
        elementName() const;

        // Documented in superclass.
        bool
        validElementName(const std::string& name) const;

      private:
        /// Assignment operator (deleted).
        Screen&
        operator= (const Screen&);

      public:
        // -- OMEModelObject API methods --

        /// @copydoc ome::xml::model::OMEModelObject::update
        virtual void
        update(const common::xml::dom::Element&  element,
               ome::xml::model::OMEModel& model);

      public:
        // -- Screen API methods --

        /// @copydoc ome::xml::model::OMEModelObject::link
        bool
        link (std::shared_ptr<Reference>& reference,
              std::shared_ptr<ome::xml::model::OMEModelObject>& object);

        /**
         * Get the Name property.
         *
         * @returns the Name property.
         */
        std::shared_ptr<std::string>
        getName ();

        /**
         * Get the Name property.
         *
         * @returns the Name property.
         */
        const std::shared_ptr<std::string>
        getName () const;

        /**
         * Set the Name property.
         *
         * @param name the value to set.
         */
        void
        setName (std::shared_ptr<std::string>& name);

        /**
         * Get the ProtocolDescription property.
         *
         * @returns the ProtocolDescription property.
         */
        std::shared_ptr<std::string>
        getProtocolDescription ();

        /**
         * Get the ProtocolDescription property.
         *
         * @returns the ProtocolDescription property.
         */
        const std::shared_ptr<std::string>
        getProtocolDescription () const;

        /**
         * Set the ProtocolDescription property.
         *
         * @param protocolDescription the value to set.
         */
        void
        setProtocolDescription (std::shared_ptr<std::string>& protocolDescription);

        /**
         * Get the ProtocolIdentifier property.
         *
         * @returns the ProtocolIdentifier property.
         */
        std::shared_ptr<std::string>
        getProtocolIdentifier ();

        /**
         * Get the ProtocolIdentifier property.
         *
         * @returns the ProtocolIdentifier property.
         */
        const std::shared_ptr<std::string>
        getProtocolIdentifier () const;

        /**
         * Set the ProtocolIdentifier property.
         *
         * @param protocolIdentifier the value to set.
         */
        void
        setProtocolIdentifier (std::shared_ptr<std::string>& protocolIdentifier);

        /**
         * Get the ReagentSetDescription property.
         *
         * @returns the ReagentSetDescription property.
         */
        std::shared_ptr<std::string>
        getReagentSetDescription ();

        /**
         * Get the ReagentSetDescription property.
         *
         * @returns the ReagentSetDescription property.
         */
        const std::shared_ptr<std::string>
        getReagentSetDescription () const;

        /**
         * Set the ReagentSetDescription property.
         *
         * @param reagentSetDescription the value to set.
         */
        void
        setReagentSetDescription (std::shared_ptr<std::string>& reagentSetDescription);

        /**
         * Get the Type property.
         *
         * @returns the Type property.
         */
        std::shared_ptr<std::string>
        getType ();

        /**
         * Get the Type property.
         *
         * @returns the Type property.
         */
        const std::shared_ptr<std::string>
        getType () const;

        /**
         * Set the Type property.
         *
         * @param type the value to set.
         */
        void
        setType (std::shared_ptr<std::string>& type);

        /**
         * Get the ID property.
         *
         * @returns the ID property.
         */
        const std::string&
        getID () const;

        /**
         * Set the ID property.
         *
         * @param id the value to set.
         */
        void
        setID (const std::string& id);

        /**
         * Get the ReagentSetIdentifier property.
         *
         * @returns the ReagentSetIdentifier property.
         */
        std::shared_ptr<std::string>
        getReagentSetIdentifier ();

        /**
         * Get the ReagentSetIdentifier property.
         *
         * @returns the ReagentSetIdentifier property.
         */
        const std::shared_ptr<std::string>
        getReagentSetIdentifier () const;

        /**
         * Set the ReagentSetIdentifier property.
         *
         * @param reagentSetIdentifier the value to set.
         */
        void
        setReagentSetIdentifier (std::shared_ptr<std::string>& reagentSetIdentifier);

        /**
         * Get the Description property.
         *
         * @returns the Description property.
         */
        std::shared_ptr<std::string>
        getDescription ();

        /**
         * Get the Description property.
         *
         * @returns the Description property.
         */
        const std::shared_ptr<std::string>
        getDescription () const;

        /**
         * Set the Description property.
         *
         * @param description the value to set.
         */
        void
        setDescription (std::shared_ptr<std::string>& description);

        /**
         * Get size of linked Reagent list.
         *
         * @returns the size of the list.
         */
        std::vector<std::shared_ptr<ome::xml::model::Reagent>>::size_type
        sizeOfReagentList () const;

        /**
         * Get the Reagent list.
         *
         * @returns a reference to the list.
         *
         */
        std::vector<std::shared_ptr<ome::xml::model::Reagent>>&
        getReagentList ();

        /**
         * Get the Reagent list.
         *
         * @returns a reference to the list.
         *
         */
        const std::vector<std::shared_ptr<ome::xml::model::Reagent>>&
        getReagentList () const;

        /**
         * Get Reagent.
         *
         * @param index the index number of the Reagent.
         * @returns the Reagent.
         * @throws std::out_of_range if the index is invalid.
         */
        std::shared_ptr<ome::xml::model::Reagent>&
        getReagent (std::vector<std::shared_ptr<ome::xml::model::Reagent>>::size_type index);

        /**
         * Get Reagent.
         *
         * @param index the index number of the Reagent.
         * @returns the Reagent.
         * @throws std::out_of_range if the index is invalid.
         */
        const std::shared_ptr<ome::xml::model::Reagent>&
        getReagent (std::vector<std::shared_ptr<ome::xml::model::Reagent>>::size_type index) const;

        /**
         * Set Reagent.
         *
         * @param index the index number of the Reagent.
         * @param reagent the Reagent to set.
         * @throws std::out_of_range if the index is invalid.
         */
        void
        setReagent (std::vector<std::shared_ptr<ome::xml::model::Reagent>>::size_type index,
                               std::shared_ptr<ome::xml::model::Reagent>& reagent);

        /**
         * Add Reagent.
         *
         * @param reagent the Reagent to add.
         *
         * @todo Return list position?
         * @todo Detect and handle duplicates?
         */
        void
        addReagent (std::shared_ptr<ome::xml::model::Reagent>& reagent);

        /**
         * Remove Reagent.
         *
         * @param reagent the Reagent to remove.
         *
         * @todo Doesn't the removal break the indexing?
         * @todo Does the removal deal with multiple instances; we
         * aren't preventing duplicates on insertion.
         */
        void
        removeReagent (std::shared_ptr<ome::xml::model::Reagent>& reagent);

        /**
         * Get size of linked Plate list.
         *
         * @returns the size of the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Plate, std::weak_ptr>::type::size_type
        sizeOfLinkedPlateList () const;

        /**
         * Get the linked Plate list.
         *
         * @returns a reference to the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Plate, std::weak_ptr>::type
        getLinkedPlateList () const;

        /**
         * Get linked Plate.
         *
         * @param index the index number of the Plate.
         * @returns a weak pointer to the Plate.
         * @throws std::out_of_range if the index is invalid.
         */
        const std::weak_ptr<ome::xml::model::Plate>&
        getLinkedPlate (OMEModelObject::indexed_container<ome::xml::model::Plate, std::weak_ptr>::type::size_type index) const;

        /**
         * Set linked Plate.
         *
         * @note The index must be valid.
         *
         * @param index the index number of the Plate.
         * @param plate the Plate to set.
         * @returns a weak pointer to the Plate.
         * @throws std::out_of_range if the index is invalid.
         */
        const std::weak_ptr<ome::xml::model::Plate>&
        setLinkedPlate (OMEModelObject::indexed_container<ome::xml::model::Plate, std::weak_ptr>::type::size_type index,
                                     const std::shared_ptr<ome::xml::model::Plate>& plate);

        /**
         * Link Plate.
         *
         * @param plate the Plate to link.
         * @returns @c true if the object was added to the internal
         * plateLinks list, otherwise @c false.
         *
         * @todo Why have a return value here; what is it used for?
         * Is this an artifact of the Java API?
         */
        bool
        linkPlate (const std::shared_ptr<ome::xml::model::Plate>& plate);

        /**
         * Unlink Plate.
         *
         * @param plate the Plate to unlink.
         *
         * @returns @c true if the Plate was unlinked, otherwise
         * @c false if the Plate was not linked and could hence not be
         * unlinked.
         *
         * @todo Does the return value serve any useful purpose?  Is
         * this also inherited Java API?
         * @todo Doesn't the removal break the indexing?
         * @todo Does the removal deal with multiple instances; we
         * aren't preventing duplicates on insertion.
         */
        bool
        unlinkPlate (const std::shared_ptr<ome::xml::model::Plate>& plate);

        /**
         * Get size of linked Annotation list.
         *
         * @returns the size of the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Annotation, std::weak_ptr>::type::size_type
        sizeOfLinkedAnnotationList () const;

        /**
         * Get the linked Annotation list.
         *
         * @returns a reference to the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Annotation, std::weak_ptr>::type
        getLinkedAnnotationList () const;

        /**
         * Get linked Annotation.
         *
         * @param index the index number of the Annotation.
         * @returns a weak pointer to the Annotation.
         * @throws std::out_of_range if the index is invalid.
         */
        const std::weak_ptr<ome::xml::model::Annotation>&
        getLinkedAnnotation (OMEModelObject::indexed_container<ome::xml::model::Annotation, std::weak_ptr>::type::size_type index) const;

        /**
         * Set linked Annotation.
         *
         * @note The index must be valid.
         *
         * @param index the index number of the Annotation.
         * @param annotation the Annotation to set.
         * @returns a weak pointer to the Annotation.
         * @throws std::out_of_range if the index is invalid.
         */
        const std::weak_ptr<ome::xml::model::Annotation>&
        setLinkedAnnotation (OMEModelObject::indexed_container<ome::xml::model::Annotation, std::weak_ptr>::type::size_type index,
                                     const std::shared_ptr<ome::xml::model::Annotation>& annotation);

        /**
         * Link Annotation.
         *
         * @param annotation the Annotation to link.
         * @returns @c true if the object was added to the internal
         * annotationLinks list, otherwise @c false.
         *
         * @todo Why have a return value here; what is it used for?
         * Is this an artifact of the Java API?
         */
        bool
        linkAnnotation (const std::shared_ptr<ome::xml::model::Annotation>& annotation);

        /**
         * Unlink Annotation.
         *
         * @param annotation the Annotation to unlink.
         *
         * @returns @c true if the Annotation was unlinked, otherwise
         * @c false if the Annotation was not linked and could hence not be
         * unlinked.
         *
         * @todo Does the return value serve any useful purpose?  Is
         * this also inherited Java API?
         * @todo Doesn't the removal break the indexing?
         * @todo Does the removal deal with multiple instances; we
         * aren't preventing duplicates on insertion.
         */
        bool
        unlinkAnnotation (const std::shared_ptr<ome::xml::model::Annotation>& annotation);

      protected:
        // Documented in base class.
        virtual void
        asXMLElementInternal (common::xml::dom::Document& document,
                              common::xml::dom::Element&  element) const;

      public:
       // Documented in superclass.
       const std::string&
       getXMLNamespace() const;
      };

    }
  }
}

#endif // OME_XML_MODEL_SCREEN_H

/*
 * Local Variables:
 * mode:C++
 * End:
 */
