/*
 * #%L
 * OME-XML C++ library for working with OME-XML metadata structures.
 * %%
 * Copyright © 2006 - 2016 Open Microscopy Environment:
 *   - Massachusetts Institute of Technology
 *   - National Institutes of Health
 *   - University of Dundee
 *   - Board of Regents of the University of Wisconsin-Madison
 *   - Glencoe Software, Inc.
 * %%
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of any organization.
 * #L%
 */

/*─────────────────────────────────────────────────────────────────────────────
 *
 * THIS IS AUTOMATICALLY GENERATED CODE.  DO NOT MODIFY.
 *
 *─────────────────────────────────────────────────────────────────────────────
 */

#ifndef OME_XML_MODEL_TIFFDATA_H
#define OME_XML_MODEL_TIFFDATA_H

#include <algorithm>
#include <list>
#include <stdexcept>
#include <string>
#include <vector>

#include <ome/common/log.h>

#include <ome/common/xml/dom/Document.h>
#include <ome/common/xml/dom/Element.h>
#include <ome/common/xml/dom/Node.h>

#include <ome/xml/model/primitives/Quantity.h>

#include <ome/xml/model/Pixels.h>
#include <ome/xml/model/UUID.h>
#include <ome/xml/model/detail/OMEModelObject.h>
#include <ome/xml/model/primitives/NonNegativeInteger.h>

namespace ome
{
  namespace xml
  {
    namespace model
    {

      // Forward declarations.
      class OMEModel;

      /**
       * TiffData model object.
       */
      class TiffData : public detail::OMEModelObject
      {
      private:
        class Impl;
        /// Private implementation details.
        std::shared_ptr<Impl> impl;

      public:
        /// Default constructor.
        TiffData();

        /**
         * Copy constructor.
         *
         * @param copy the TiffData to copy.
         */
        TiffData (const TiffData& copy);

        /// Destructor.
        virtual
        ~TiffData ();

        /**
         * Create a TiffData model object from DOM element.
         *
         * @param element root of the XML DOM tree to from which to
         * construct the model object graph.
         * @param model handler for the OME model used to track
         * instances and references seen during the update.
         * @throws EnumerationException if there is an error
         * instantiating an enumeration during model object creation,
         * or ModelException if there are any consistency or validity
         * errors found during processing.
         *
         * @returns a new model object.
         */
        static std::shared_ptr<TiffData>
        create(const common::xml::dom::Element& element,
               ome::xml::model::OMEModel& model);

        // Documented in superclass.
        const std::string&
        elementName() const;

        // Documented in superclass.
        bool
        validElementName(const std::string& name) const;

      private:
        /// Assignment operator (deleted).
        TiffData&
        operator= (const TiffData&);

      public:
        // -- OMEModelObject API methods --

        /// @copydoc ome::xml::model::OMEModelObject::update
        virtual void
        update(const common::xml::dom::Element&  element,
               ome::xml::model::OMEModel& model);

      public:
        // -- TiffData API methods --

        /// @copydoc ome::xml::model::OMEModelObject::link
        bool
        link (std::shared_ptr<Reference>& reference,
              std::shared_ptr<ome::xml::model::OMEModelObject>& object);

        /**
         * Get the IFD property.
         *
         * @returns the IFD property.
         */
        std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getIFD ();

        /**
         * Get the IFD property.
         *
         * @returns the IFD property.
         */
        const std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getIFD () const;

        /**
         * Set the IFD property.
         *
         * @param ifd the value to set.
         */
        void
        setIFD (std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>& ifd);

        /**
         * Get the PlaneCount property.
         *
         * @returns the PlaneCount property.
         */
        std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getPlaneCount ();

        /**
         * Get the PlaneCount property.
         *
         * @returns the PlaneCount property.
         */
        const std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getPlaneCount () const;

        /**
         * Set the PlaneCount property.
         *
         * @param planeCount the value to set.
         */
        void
        setPlaneCount (std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>& planeCount);

        /**
         * Get the FirstZ property.
         *
         * @returns the FirstZ property.
         */
        std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstZ ();

        /**
         * Get the FirstZ property.
         *
         * @returns the FirstZ property.
         */
        const std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstZ () const;

        /**
         * Set the FirstZ property.
         *
         * @param firstZ the value to set.
         */
        void
        setFirstZ (std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>& firstZ);

        /**
         * Get the FirstC property.
         *
         * @returns the FirstC property.
         */
        std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstC ();

        /**
         * Get the FirstC property.
         *
         * @returns the FirstC property.
         */
        const std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstC () const;

        /**
         * Set the FirstC property.
         *
         * @param firstC the value to set.
         */
        void
        setFirstC (std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>& firstC);

        /**
         * Get the FirstT property.
         *
         * @returns the FirstT property.
         */
        std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstT ();

        /**
         * Get the FirstT property.
         *
         * @returns the FirstT property.
         */
        const std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>
        getFirstT () const;

        /**
         * Set the FirstT property.
         *
         * @param firstT the value to set.
         */
        void
        setFirstT (std::shared_ptr<ome::xml::model::primitives::NonNegativeInteger>& firstT);

        /**
         * Get the UUID property.
         *
         * @returns the UUID property.
         */
        std::shared_ptr<ome::xml::model::UUID>
        getUUID ();

        /**
         * Get the UUID property.
         *
         * @returns the UUID property.
         */
        const std::shared_ptr<ome::xml::model::UUID>
        getUUID () const;

        /**
         * Set the UUID property.
         *
         * @param uuid the value to set.
         */
        void
        setUUID (std::shared_ptr<ome::xml::model::UUID>& uuid);

        /**
         * Get the Pixels property.
         *
         * @returns the Pixels property.
         */
        std::weak_ptr<ome::xml::model::Pixels>
        getPixels ();

        /**
         * Get the Pixels property.
         *
         * @returns the Pixels property.
         */
        const std::weak_ptr<ome::xml::model::Pixels>
        getPixels () const;

        /**
         * Set the Pixels property.
         *
         * @param pixels_BackReference the value to set.
         */
        void
        setPixels (std::weak_ptr<ome::xml::model::Pixels>& pixels_BackReference);

      protected:
        // Documented in base class.
        virtual void
        asXMLElementInternal (common::xml::dom::Document& document,
                              common::xml::dom::Element&  element) const;

      public:
       // Documented in superclass.
       const std::string&
       getXMLNamespace() const;
      };

    }
  }
}

#endif // OME_XML_MODEL_TIFFDATA_H

/*
 * Local Variables:
 * mode:C++
 * End:
 */
